// Copyright 2016 Orus.io. All rights reserved.

package storage

import (
	"github.com/m4rw3r/uuid"

	"bitbucket.org/orus-io/go-xbus/api"
)

// AccountStorage is in charge of storing account definitions.
// When multiple instances are running, CRUD operations be reflected from one
// to the others
type AccountStorage interface {
	Get(id uuid.UUID) (api.Account, bool)
	GetByName(name string) (api.Account, bool)
	GetByCert(cert string) (api.Account, bool)
	GetByAPIKey(key string) (api.Account, bool)

	Create(api.Account) (api.Account, error)
	Update(api.Account) (api.Account, error)
	Delete(api.Account)

	List() []api.Account
}
