// Copyright 2017 Orus.io. All rights reserved.

package api

import (
	"github.com/m4rw3r/uuid"
)

// API for clients

const (
	// ClientPrefix is the prefix for client api subjects
	ClientPrefix = XbusAPIPrefix + "client."
)

const (
	// ClientGetActors is the subject suffix for ClientGetActors function
	ClientGetActors = "get_actors"
)

// ClientSubject calculate the subject of a Client function
func ClientSubject(accountID uuid.UUID, fname string) string {
	return ClientPrefix +
		UUIDToStringOrWildcard(accountID) + "." + fname
}

// ClientGetActorsReq is the reply type of ClientGetActors
type ClientGetActorsReq uuid.UUID

// ClientGetActorsRep is the reply type of ClientGetActors
type ClientGetActorsRep struct {
	Response
	Actors []Actor
}

// WhoAmISubjects returns the subject/reply subjects for a WhoAmI req/rep
func WhoAmISubjects(apiKey string) (string, string) {
	base := ClientPrefix + "whoami." + apiKey
	return base, base + ".reply"
}

// WhoAmIReq is the req of a WhoAmI
type WhoAmIReq string

// WhoAmIRep is the rep of a WhoAmI
type WhoAmIRep struct {
	Response
	Account Account
}
