package api

import (
	"github.com/m4rw3r/uuid"
)

const (
	// EmissionServicePrefix is the prefix for the emission service
	EmissionServicePrefix = ServicesPrefix + "emission."

	// EmissionSignalSubjet is the subject for sending EmissionSignal messages
	EmissionSignalSubjet = EmissionServicePrefix + "signal"
)

// EnvelopeTarget is the target of an envelope
type EnvelopeTarget struct {
	ActorID uuid.UUID
	NodeID  string
	Input   string
}

// EmissionSignal can be sent on EmissionSignalSubjet.
type EmissionSignal struct {
	ProcessID  uuid.UUID
	EnvelopeID uuid.UUID
	Target     EnvelopeTarget
}
